/*
 * Copyright (C) 2004 emuWorks
 * http://games.technoplaza.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "chtcodelist.hh"
#include "../exceptions/indexoutofboundsexception.hh"

CHTCodeList::CHTCodeList() {
    chtlist = new std::vector<CHTCode>;
}

CHTCodeList::~CHTCodeList() {
    delete chtlist;
}

void CHTCodeList::add(CHTCode &code) {
    chtlist->push_back(code);
}

CHTCode &CHTCodeList::remove(int index) {
    if ((index < 0) || (index >= chtlist->size())) {
        throw IndexOutOfBoundsException();
    }
    
    std::vector<CHTCode> *temp = new std::vector<CHTCode>;
    CHTCode &removed = (*chtlist)[index];
    
    for (int i = 0; i < index; i++) {
        temp->push_back((*chtlist)[i]);
    }
    
    for (int i = index + 1; i < chtlist->size(); i++) {
        temp->push_back((*chtlist)[i]);
    }
    
    delete chtlist;
    chtlist = temp;
    
    return removed;
}

CHTCode &CHTCodeList::get(int index) {
    if ((index < 0) || (index >= chtlist->size())) {
        throw IndexOutOfBoundsException();
    }
    
    return (*chtlist)[index];
}

