/*
 * Copyright (C) 2004 emuWorks
 * http://games.technoplaza.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _CHTCODELIST_H
#define _CHTCODELIST_H

#include "chtcode.hh"
#include <vector>

class CHTCodeList {
public:
    CHTCodeList();
    ~CHTCodeList();

    void add(CHTCode &);
    CHTCode &remove(int); // throws IndexOutOfBoundsException
    CHTCode &get(int); // throws IndexOutOfBoundsException
    int size() { return chtlist->size(); }
    bool isEmpty() { return (size() == 0); }
    void clear() { chtlist->empty(); }

private:
    std::vector<CHTCode> *chtlist;
};

#endif

